diff --git a/web/regression/javascript/fake_endpoints.js b/web/regression/javascript/fake_endpoints.js
index fd5ec175f..79686fe55 100644
--- a/web/regression/javascript/fake_endpoints.js
+++ b/web/regression/javascript/fake_endpoints.js
@@ -28,5 +28,13 @@ define(function () {
     'erd.sql': '/erd/sql/<int:trans_id>/<int:sgid>/<int:sid>/<int:did>',
     'erd.prequisite': '/erd/prequisite/<int:trans_id>/<int:sgid>/<int:sid>/<int:did>',
     'erd.tables': '/erd/tables/<int:trans_id>/<int:sgid>/<int:sid>/<int:did>',
+    'file_manager.init': '/file_manager/init',
+    'file_manager.filemanager': '/file_manager/init',
+    'file_manager.index': '/file_manager/',
+    'file_manager.delete_trans_id': '/file_manager/delete_trans_id/<int:trans_id>',
+    'file_manager.save_last_dir': '/file_manager/save_last_dir/<int:trans_id>',
+    'file_manager.save_file_dialog_view': '/file_manager/save_file_dialog_view/<int:trans_id>',
+    'file_manager.save_show_hidden_file_option': '/file_manager/save_show_hidden_file_option/<int:trans_id>',
+    'settings.save_file_format_setting': '/settings/save_file_format_setting/',
   };
 });
diff --git a/web/regression/javascript/file_manager/FileManager.spec.js b/web/regression/javascript/file_manager/FileManager.spec.js
new file mode 100644
index 000000000..c41136796
--- /dev/null
+++ b/web/regression/javascript/file_manager/FileManager.spec.js
@@ -0,0 +1,324 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import Theme from '../../../pgadmin/static/js/Theme';
+import FileManager, { FileManagerUtils, getComparator } from '../../../pgadmin/misc/file_manager/static/js/components/FileManager';
+import MockAdapter from 'axios-mock-adapter';
+import axios from 'axios/index';
+import getApiInstance from '../../../pgadmin/static/js/api_instance';
+import * as pgUtils from '../../../pgadmin/static/js/utils';
+
+const files = [
+  {
+    'Filename': 'file1.sql',
+    'Path': '/home/file1',
+    'file_type': 'sql',
+    'Protected': 0,
+    'Properties': {
+      'Date Created': 'Fri Oct 22 16:59:24 2021',
+      'Date Modified': 'Tue Oct 12 14:08:00 2021',
+      'Size': '1.4 MB'
+    }
+  },
+  {
+    'Filename': 'folder1',
+    'Path': '/home/folder1',
+    'file_type': 'dir',
+    'Protected': 0,
+    'Properties': {
+      'Date Created': 'Fri Oct 22 16:59:24 2021',
+      'Date Modified': 'Tue Oct 12 14:08:00 2021',
+      'Size': '1.4 MB'
+    }
+  }
+];
+
+const transId = 140391;
+const configData = {
+  'transId': transId,
+  'options': {
+    'culture': 'en',
+    'lang': 'py',
+    'defaultViewMode':'list',
+    'autoload': true,
+    'showFullPath': false,
+    'dialog_type': 'select_folder',
+    'show_hidden_files': false,
+    'fileRoot': '/home/current',
+    'capabilities': [
+      'select_folder', 'select_file', 'download',
+      'rename', 'delete', 'upload', 'create'
+    ],
+    'allowed_file_types': [
+      '*',
+      'sql',
+      'backup'
+    ],
+    'platform_type': 'darwin',
+    'show_volumes': true,
+    'homedir': '/home/',
+    'last_selected_format': '*'
+  },
+  'security': {
+    'uploadPolicy': '',
+    'uploadRestrictions': [
+      '*',
+      'sql',
+      'backup'
+    ]
+  },
+  'upload': {
+    'multiple': true,
+    'number': 20,
+    'fileSizeLimit': 50,
+    'imagesOnly': false
+  }
+};
+
+const params={
+  dialog_type: 'select_file',
+};
+
+describe('FileManger', ()=>{
+  let mount;
+  let networkMock;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+    networkMock = new MockAdapter(axios);
+    networkMock.onPost('/file_manager/init').reply(200, {'data': configData});
+    networkMock.onPost(`/file_manager/filemanager/${transId}/`).reply(200, {data: {result: files}});
+    networkMock.onDelete(`/file_manager/delete_trans_id/${transId}`).reply(200, {});
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+    networkMock.restore();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+  });
+
+  describe('FileManger', ()=>{
+    let closeModal=jasmine.createSpy('closeModal'),
+      onOK=jasmine.createSpy('onOK'),
+      onCancel=jasmine.createSpy('onCancel'),
+      ctrlMount = (props)=>{
+        return mount(<Theme>
+          <FileManager
+            params={params}
+            closeModal={closeModal}
+            onOK={onOK}
+            onCancel={onCancel}
+            {...props}
+          />
+        </Theme>);
+      };
+
+    it('init', (done)=>{
+      let ctrl = ctrlMount({});
+      setTimeout(()=>{
+        ctrl.update();
+        expect(ctrl.find('ListView').length).toBe(1);
+        expect(ctrl.find('GridView').length).toBe(0);
+        expect(ctrl.find('InputText[data-label="file-path"]').prop('value')).toBe('/home/current');
+        ctrl?.unmount();
+        let config = {...configData};
+        config.options.defaultViewMode = 'grid';
+        networkMock.onPost('/file_manager/init').reply(200, {'data': config});
+        ctrl = ctrlMount({});
+        setTimeout(()=>{
+          ctrl.update();
+          expect(ctrl.find('ListView').length).toBe(0);
+          expect(ctrl.find('GridView').length).toBe(1);
+          ctrl?.unmount();
+          done();
+        }, 0);
+      }, 500);
+    });
+
+    describe('getComparator', ()=>{
+      it('Filename', ()=>{
+        expect(getComparator({columnKey: 'Filename', direction: 'ASC'})({Filename:'a'}, {Filename:'b'})).toBe(-1);
+        expect(getComparator({columnKey: 'Filename', direction: 'DESC'})({Filename:'a'}, {Filename:'b'})).toBe(1);
+        expect(getComparator({columnKey: 'Filename', direction: 'ASC'})({Filename:'a'}, {Filename:'A'})).toBe(-1);
+      });
+
+      it('Properties.DateModified', ()=>{
+        expect(getComparator({columnKey: 'Properties.DateModified', direction: 'ASC'})(
+          {Properties:{'Date Modified':'Tue Feb 25 11:36:28 2020'}}, {Properties:{'Date Modified':'Tue Feb 26 11:36:28 2020'}})
+        ).toBe(-1);
+        expect(getComparator({columnKey: 'Properties.DateModified', direction: 'DESC'})(
+          {Properties:{'Date Modified':'Tue Feb 25 11:36:28 2020'}}, {Properties:{'Date Modified':'Tue Feb 26 11:36:28 2020'}})
+        ).toBe(1);
+        expect(getComparator({columnKey: 'Properties.DateModified', direction: 'ASC'})(
+          {Properties:{'Date Modified':'Tue Feb 25 11:36:28 2020'}}, {Properties:{'Date Modified':'Tue Feb 25 11:36:28 2020'}})
+        ).toBe(0);
+      });
+
+      it('Properties.Size', ()=>{
+        expect(getComparator({columnKey: 'Properties.Size', direction: 'ASC'})(
+          {Properties:{'Size':'1 KB'}}, {Properties:{'Size':'1 MB'}})
+        ).toBe(-1);
+        expect(getComparator({columnKey: 'Properties.Size', direction: 'DESC'})(
+          {Properties:{'Size':'1 MB'}}, {Properties:{'Size':'1 GB'}})
+        ).toBe(1);
+        expect(getComparator({columnKey: 'Properties.Size', direction: 'ASC'})(
+          {Properties:{'Size':'1 MB'}}, {Properties:{'Size':'1 MB'}})
+        ).toBe(0);
+      });
+    });
+  });
+});
+
+describe('FileManagerUtils', ()=>{
+  let api, fmObj, networkMock;
+  beforeEach(()=>{
+    networkMock = new MockAdapter(axios);
+    networkMock.onDelete(`/file_manager/delete_trans_id/${transId}`).reply(200, {});
+    networkMock.onPost(`/file_manager/filemanager/${transId}/`).reply((config)=>{
+      let retVal = {};
+      let apiData = JSON.parse(config.data);
+      let headers = {};
+      if(apiData.mode == 'addfolder') {
+        retVal = {data: {result: {
+          Name: apiData.name,
+          Path: '/home/'+apiData.name,
+          'Date Modified': 'Tue Feb 25 11:36:28 2020',
+        }}};
+      } else if(apiData.mode == 'rename') {
+        retVal = {data: {result: {
+          'New Path': '/home/'+apiData.new,
+          'New Name': apiData.new,
+        }}};
+      } else if(apiData.mode == 'download') {
+        retVal = 'blobdata';
+        headers = {filename: 'newfile1'};
+      } else if(apiData.mode == 'is_file_exist') {
+        retVal = {data: {result: {Code: 1}}};
+      }
+      return [200, retVal, headers];
+    });
+
+    api = getApiInstance();
+    fmObj = new FileManagerUtils(api, params);
+    fmObj.config = configData;
+  });
+
+  afterEach(()=>{
+    networkMock.restore();
+  });
+
+  it('showHiddenFiles', ()=>{
+    expect(fmObj.showHiddenFiles).toBe(false);
+    networkMock.onPut(`/file_manager/save_show_hidden_file_option/${transId}`).reply(200, {});
+    fmObj.showHiddenFiles = true;
+    expect(fmObj.config.options?.show_hidden_files).toBe(true);
+  });
+
+  it('setLastVisitedDir', async ()=>{
+    let calledPath = null;
+    networkMock.onPost(`/file_manager/save_last_dir/${transId}`).reply((config)=>{
+      calledPath = JSON.parse(config.data).path;
+      return [200, {}];
+    });
+    await fmObj.setLastVisitedDir('/home/xyz');
+    expect(calledPath).toBe('/home/xyz');
+  });
+
+  it('setDialogView', async ()=>{
+    networkMock.onPost(`/file_manager/save_file_dialog_view/${transId}`).reply(200, {});
+    await fmObj.setDialogView('grid');
+    expect(fmObj.config.options.defaultViewMode).toBe('grid');
+  });
+
+  it('setFileType', async ()=>{
+    networkMock.onPost('/settings/save_file_format_setting/').reply(200, {});
+    await fmObj.setFileType('pgerd');
+    expect(fmObj.config.options.last_selected_format).toBe('pgerd');
+  });
+
+  it('join', ()=>{
+    expect(fmObj.join('/dir1/dir2', 'file1')).toBe('/dir1/dir2/file1');
+    expect(fmObj.join('/dir1/dir2/', 'file1')).toBe('/dir1/dir2/file1');
+  });
+
+  it('addFolder', async ()=>{
+    let res = await fmObj.addFolder({Filename: 'newfolder'});
+    expect(res).toEqual({
+      Filename: 'newfolder',
+      Path: '/home/newfolder',
+      file_type: 'dir',
+      Properties: {
+        'Date Modified': 'Tue Feb 25 11:36:28 2020',
+      }
+    });
+  });
+
+  it('rename', async ()=>{
+    let row = {Filename: 'newfolder1', Path: '/home/newfolder'};
+    let res = await fmObj.renameItem(row);
+    expect(res).toEqual({
+      Filename: 'newfolder1',
+      Path: '/home/newfolder1',
+    });
+  });
+
+  it('deleteItem', async ()=>{
+    let row = {Filename: 'newfolder', Path: '/home/newfolder'};
+    let path = await fmObj.deleteItem(row);
+    expect(path).toBe('/home/newfolder');
+
+    path = await fmObj.deleteItem(row, 'file1');
+    expect(path).toBe('/home/newfolder/file1');
+  });
+
+  it('checkPermission', async ()=>{
+    networkMock.reset();
+    networkMock.onPost(`/file_manager/filemanager/${transId}/`).reply(200, {
+      data: {
+        result: {
+          Code: 1,
+        }
+      }
+    });
+    let res = await fmObj.checkPermission('/home/newfolder');
+    expect(res).toEqual(null);
+
+    networkMock.onPost(`/file_manager/filemanager/${transId}/`).reply(200, {
+      data: {
+        result: {
+          Code: 0,
+          Error: 'file error'
+        }
+      }
+    });
+    res = await fmObj.checkPermission('/home/newfolder');
+    expect(res).toEqual('file error');
+  });
+
+  it('isFileExists', async ()=>{
+    let res = await fmObj.isFileExists('/home/newfolder', 'newfile1');
+    expect(res).toBe(true);
+  });
+
+  it('downloadFile', async ()=>{
+    spyOn(pgUtils, 'downloadBlob');
+    let row = {Filename: 'newfile1', Path: '/home/newfile1'};
+    await fmObj.downloadFile(row);
+    expect(pgUtils.downloadBlob).toHaveBeenCalledWith('blobdata', 'newfile1');
+  });
+});
diff --git a/web/regression/javascript/file_manager/GridView.spec.js b/web/regression/javascript/file_manager/GridView.spec.js
new file mode 100644
index 000000000..b2bb7483e
--- /dev/null
+++ b/web/regression/javascript/file_manager/GridView.spec.js
@@ -0,0 +1,62 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import Theme from '../../../pgadmin/static/js/Theme';
+import { ItemView } from '../../../pgadmin/misc/file_manager/static/js/components/GridView';
+
+describe('GridView', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+  });
+
+  describe('ItemView', ()=>{
+    let row = {'Filename': 'test.sql', 'Size': '1KB', 'file_type': 'dir'},
+      ctrlMount = (props)=>{
+        return mount(<Theme>
+          <ItemView
+            idx={0}
+            selected={false}
+            row={row}
+            {...props}
+          />
+        </Theme>);
+      };
+
+    it('keydown Escape', (done)=>{
+      const onEditComplete = jasmine.createSpy('onEditComplete');
+      let ctrl = ctrlMount({
+        onEditComplete: onEditComplete,
+      });
+      setTimeout(()=>{
+        ctrl.update();
+        ctrl.find('div[data-test="filename-div"]').simulate('keydown', { code: 'Escape'});
+        setTimeout(()=>{
+          expect(onEditComplete).toHaveBeenCalled();
+          done();
+        });
+      }, 0);
+    });
+  });
+});
diff --git a/web/regression/javascript/file_manager/ListView.spec.js b/web/regression/javascript/file_manager/ListView.spec.js
new file mode 100644
index 000000000..8036579ae
--- /dev/null
+++ b/web/regression/javascript/file_manager/ListView.spec.js
@@ -0,0 +1,110 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import Theme from '../../../pgadmin/static/js/Theme';
+import { CustomRow, FileNameEditor, GridContextUtils } from '../../../pgadmin/misc/file_manager/static/js/components/ListView';
+
+describe('ListView', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+  });
+
+  describe('FileNameEditor', ()=>{
+    let row = {'Filename': 'test.sql', 'Size': '1KB'},
+      column = {
+        key: 'Filename'
+      },
+      ctrlMount = (props)=>{
+        return mount(<Theme>
+          <FileNameEditor
+            row={row}
+            column={column}
+            {...props}
+          />
+        </Theme>);
+      };
+
+    it('init', (done)=>{
+      let ctrl = ctrlMount({
+        onRowChange: ()=>{/* test func */},
+        onClose: ()=>{/* test func */},
+      });
+      setTimeout(()=>{
+        ctrl.update();
+        expect(ctrl.find('input').props()).toEqual(jasmine.objectContaining({value: 'test.sql'}));
+        done();
+      }, 0);
+    });
+
+    it('keydown Tab', (done)=>{
+      let onCloseSpy = jasmine.createSpy('onClose');
+      let ctrl = ctrlMount({
+        onRowChange: ()=>{/* test func */},
+        onClose: onCloseSpy,
+      });
+      setTimeout(()=>{
+        ctrl.update();
+        expect(ctrl.find('input').props()).toEqual(jasmine.objectContaining({value: 'test.sql'}));
+        ctrl.find('input').simulate('keydown', { code: 'Tab'});
+        setTimeout(()=>{
+          expect(onCloseSpy).toHaveBeenCalled();
+          done();
+        });
+      }, 0);
+    });
+  });
+
+  describe('CustomRow', ()=>{
+    let row = {'Filename': 'test.sql', 'Size': '1KB'},
+      ctrlMount = (onItemSelect, onItemEnter)=>{
+        return mount(<Theme>
+          <GridContextUtils.Provider value={{onItemSelect, onItemEnter}}>
+            <CustomRow
+              row={row}
+              selectedCellIdx={0}
+              rowIdx={0}
+              inTest={true}
+            />
+          </GridContextUtils.Provider>
+        </Theme>);
+      };
+
+    it('init', (done)=>{
+      let onItemSelect = jasmine.createSpy('onItemSelect');
+      let onItemEnter = jasmine.createSpy('onItemEnter');
+      let ctrl = ctrlMount(onItemSelect, onItemEnter);
+      setTimeout(()=>{
+        ctrl.update();
+        ctrl.find('div[data-test="test-div"]').simulate('keydown', { code: 'Enter'});
+        setTimeout(()=>{
+          ctrl.update();
+          expect(onItemEnter).toHaveBeenCalled();
+          ctrl?.unmount();
+          done();
+        }, 0);
+      }, 0);
+    });
+  });
+});
diff --git a/web/regression/javascript/file_manager/Uploader.spec.js b/web/regression/javascript/file_manager/Uploader.spec.js
new file mode 100644
index 000000000..4f6cb5fad
--- /dev/null
+++ b/web/regression/javascript/file_manager/Uploader.spec.js
@@ -0,0 +1,254 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import jasmineEnzyme from 'jasmine-enzyme';
+import React from 'react';
+import '../helper/enzyme.helper';
+import { createMount } from '@material-ui/core/test-utils';
+import Theme from '../../../pgadmin/static/js/Theme';
+import Uploader, { filesReducer, getFileSize, UploadedFile } from '../../../pgadmin/misc/file_manager/static/js/components/Uploader';
+import { MESSAGE_TYPE } from '../../../pgadmin/static/js/components/FormComponents';
+
+describe('GridView', ()=>{
+  let mount;
+
+  /* Use createMount so that material ui components gets the required context */
+  /* https://material-ui.com/guides/testing/#api */
+  beforeAll(()=>{
+    mount = createMount();
+  });
+
+  afterAll(() => {
+    mount.cleanUp();
+  });
+
+  beforeEach(()=>{
+    jasmineEnzyme();
+  });
+
+  describe('Uploader', ()=>{
+    let fmUtilsObj = jasmine.createSpyObj('fmUtilsObj', ['uploadItem', 'deleteItem'], ['currPath']);
+    let onClose = jasmine.createSpy('onClose');
+    let ctrlMount = (props)=>{
+      return mount(<Theme>
+        <Uploader
+          fmUtilsObj={fmUtilsObj}
+          onClose={onClose}
+          {...props}
+        />
+      </Theme>);
+    };
+
+    it('init', (done)=>{
+      let ctrl = ctrlMount();
+      setTimeout(()=>{
+        ctrl.update();
+        done();
+      }, 0);
+    });
+
+    describe('filesReducer', ()=>{
+      let state;
+
+      beforeEach(()=>{
+        state = [
+          {
+            id: 1,
+            file: 'file1',
+            progress: 0,
+            started: false,
+            failed: false,
+            done: false,
+            deleting: false,
+          }
+        ];
+      });
+
+      it('add', ()=>{
+        let newState = filesReducer(state, {
+          type: 'add',
+          files: ['new1'],
+        });
+        expect(newState.length).toBe(2);
+        expect(newState[0]).toEqual(jasmine.objectContaining({
+          file: 'new1',
+          progress: 0,
+          started: false,
+          failed: false,
+          done: false,
+          deleting: false,
+        }));
+      });
+
+
+      it('started', ()=>{
+        let newState = filesReducer(state, {
+          type: 'started',
+          id: 1,
+        });
+        expect(newState[0]).toEqual(jasmine.objectContaining({
+          file: 'file1',
+          progress: 0,
+          started: true,
+          failed: false,
+          done: false,
+          deleting: false,
+        }));
+      });
+
+      it('started', ()=>{
+        let newState = filesReducer(state, {
+          type: 'progress',
+          id: 1,
+          value: 14,
+        });
+        expect(newState[0]).toEqual(jasmine.objectContaining({
+          file: 'file1',
+          progress: 14,
+          started: false,
+          failed: false,
+          done: false,
+          deleting: false,
+        }));
+      });
+
+      it('failed', ()=>{
+        let newState = filesReducer(state, {
+          type: 'failed',
+          id: 1,
+        });
+        expect(newState[0]).toEqual(jasmine.objectContaining({
+          file: 'file1',
+          progress: 0,
+          started: false,
+          failed: true,
+          done: false,
+          deleting: false,
+        }));
+      });
+
+      it('done', ()=>{
+        let newState = filesReducer(state, {
+          type: 'done',
+          id: 1,
+        });
+        expect(newState[0]).toEqual(jasmine.objectContaining({
+          file: 'file1',
+          progress: 0,
+          started: false,
+          failed: false,
+          done: true,
+          deleting: false,
+        }));
+      });
+
+      it('deleting', ()=>{
+        let newState = filesReducer(state, {
+          type: 'deleting',
+          id: 1,
+        });
+        expect(newState[0]).toEqual(jasmine.objectContaining({
+          file: 'file1',
+          progress: 0,
+          started: false,
+          failed: false,
+          done: false,
+          deleting: true,
+        }));
+      });
+
+      it('delete', ()=>{
+        let newState = filesReducer(state, {
+          type: 'delete',
+          id: 1,
+        });
+        expect(newState.length).toBe(0);
+      });
+    });
+
+    it('getFileSize', ()=>{
+      expect(getFileSize(1024)).toBe('1 KB');
+    });
+
+    describe('UploadedFile', ()=>{
+      let upCtrlMount = (props)=>{
+        return mount(<Theme>
+          <UploadedFile
+            deleteFile={()=>{/*dummy*/}}
+            onClose={onClose}
+            {...props}
+          />
+        </Theme>);
+      };
+
+      it('uploading', (done)=>{
+        let ctrl = upCtrlMount({upfile: {
+          file: {
+            name: 'file1',
+            size: '1KB',
+          },
+          done: false,
+          failed: false,
+          progress: 14,
+        }});
+
+        setTimeout(()=>{
+          ctrl.update();
+          expect(ctrl.find('FormFooterMessage').props()).toEqual(jasmine.objectContaining({
+            type: MESSAGE_TYPE.INFO,
+            message: 'Uploading... 14%',
+          }));
+          done();
+        }, 0);
+      });
+
+      it('done', (done)=>{
+        let ctrl = upCtrlMount({upfile: {
+          file: {
+            name: 'file1',
+            size: '1KB',
+          },
+          done: true,
+          failed: false,
+          progress: 14,
+        }});
+
+        setTimeout(()=>{
+          ctrl.update();
+          expect(ctrl.find('FormFooterMessage').props()).toEqual(jasmine.objectContaining({
+            type: MESSAGE_TYPE.SUCCESS,
+            message: 'Uploaded!',
+          }));
+          done();
+        }, 0);
+      });
+
+      it('failed', (done)=>{
+        let ctrl = upCtrlMount({upfile: {
+          file: {
+            name: 'file1',
+            size: '1KB',
+          },
+          done: false,
+          failed: true,
+          progress: 14,
+        }});
+
+        setTimeout(()=>{
+          ctrl.update();
+          expect(ctrl.find('FormFooterMessage').props()).toEqual(jasmine.objectContaining({
+            type: MESSAGE_TYPE.ERROR,
+            message: 'Failed!',
+          }));
+          done();
+        }, 0);
+      });
+    });
+  });
+});
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 210627608..8873198a4 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -381,7 +381,6 @@ module.exports = [{
     schema_diff: './pgadmin/tools/schema_diff/static/js/schema_diff_hook.js',
     erd_tool: './pgadmin/tools/erd/static/js/erd_tool_hook.js',
     psql_tool: './pgadmin/tools/psql/static/js/index.js',
-    file_utils: './pgadmin/misc/file_manager/static/js/utility.js',
     debugger: './pgadmin/tools/debugger/static/js/index.js',
     'pgadmin.style': pgadminCssStyles,
     pgadmin: pgadminScssStyles,
@@ -535,7 +534,6 @@ module.exports = [{
           imports: [
             'pure|pgadmin.about',
             'pure|pgadmin.preferences',
-            'pure|pgadmin.file_manager',
             'pure|pgadmin.settings',
             'pure|pgadmin.tools.backup',
             'pure|pgadmin.tools.restore',
@@ -546,7 +544,7 @@ module.exports = [{
             'pure|pgadmin.tools.debugger',
             'pure|pgadmin.node.pga_job',
             'pure|pgadmin.tools.schema_diff',
-            'pure|pgadmin.tools.storage_manager',
+            'pure|pgadmin.tools.file_manager',
             'pure|pgadmin.tools.search_objects',
             'pure|pgadmin.tools.erd_module',
             'pure|pgadmin.tools.psql_module',
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 4d5d13d9b..14cc6ef91 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -144,7 +144,6 @@ var webpackShimConfig = {
     'snap.svg': path.join(__dirname, './node_modules/snapsvg-cjs/dist/snap.svg-cjs'),
     'color-picker': path.join(__dirname, './node_modules/@simonwep/pickr/dist/pickr.es5.min'),
     'mousetrap': path.join(__dirname, './node_modules/mousetrap'),
-    'tablesorter-metric': path.join(__dirname, './node_modules/tablesorter/dist/js/parsers/parser-metric.min'),
     'pathfinding':  path.join(__dirname, 'node_modules/pathfinding'),
     'dagre':  path.join(__dirname, 'node_modules/dagre'),
     'graphlib': path.join(__dirname, 'node_modules/graphlib'),
@@ -205,8 +204,6 @@ var webpackShimConfig = {
     'pgadmin.browser.utils': '/browser/js/utils',
     'pgadmin.browser.wizard': path.join(__dirname, './pgadmin/browser/static/js/wizard'),
     'pgadmin.dashboard': path.join(__dirname, './pgadmin/dashboard/static/js/Dashboard'),
-    'pgadmin.file_manager': path.join(__dirname, './pgadmin/misc/file_manager/static/js/file_manager'),
-    'pgadmin.file_utility': path.join(__dirname, './pgadmin/misc/file_manager/static/js/utility'),
     'pgadmin.help': path.join(__dirname, './pgadmin/help/static/js/help'),
     'pgadmin.misc.explain': path.join(__dirname, './pgadmin/misc/static/explain/js/explain'),
     'pgadmin.misc.cloud': path.join(__dirname, './pgadmin/misc/cloud/static/js/cloud'),
@@ -278,6 +275,7 @@ var webpackShimConfig = {
     'pgadmin.tools.debugger': path.join(__dirname, './pgadmin/tools/debugger/static/js/'),
     'pgadmin.tools.debugger.ui': path.join(__dirname, './pgadmin/tools/debugger/static/js/debugger_ui'),
     'pgadmin.tools.debugger.utils': path.join(__dirname, './pgadmin/tools/debugger/static/js/debugger_utils'),
+    'pgadmin.tools.file_manager': path.join(__dirname, './pgadmin/misc/file_manager/static/js'),
     'pgadmin.tools.grant_wizard': path.join(__dirname, './pgadmin/tools/grant_wizard/static/js/grant_wizard'),
     'pgadmin.tools.import_export': path.join(__dirname, './pgadmin/tools/import_export/static/js/import_export'),
     'pgadmin.tools.import_export_servers': path.join(__dirname, './pgadmin/tools/import_export_servers/static/js/'),
@@ -286,7 +284,6 @@ var webpackShimConfig = {
     'pgadmin.tools.schema_diff': path.join(__dirname, './pgadmin/tools/schema_diff/static/js/schema_diff'),
     'pgadmin.tools.schema_diff_ui': path.join(__dirname, './pgadmin/tools/schema_diff/static/js/schema_diff_ui'),
     'pgadmin.tools.search_objects': path.join(__dirname, './pgadmin/tools/search_objects/static/js/search_objects'),
-    'pgadmin.tools.storage_manager': path.join(__dirname, './pgadmin/tools/storage_manager/static/js/storage_manager'),
     'pgadmin.tools.erd_module': path.join(__dirname, './pgadmin/tools/erd/static/js/erd_module'),
     'pgadmin.tools.erd': path.join(__dirname, './pgadmin/tools/erd/static/js'),
     'pgadmin.tools.psql_module': path.join(__dirname, './pgadmin/tools/psql/static/js/psql_module'),
@@ -315,8 +312,8 @@ var webpackShimConfig = {
     'pgadmin.browser.server.variable', 'pgadmin.browser.collection', 'pgadmin.browser.node.ui',
     'pgadmin.browser.datamodel', 'pgadmin.browser.menu', 'pgadmin.browser.panel', 'pgadmin',
     'pgadmin.browser.frame', 'slick.pgadmin.editors', 'slick.pgadmin.formatters',
-    'pgadmin.backform', 'pgadmin.backgrid', 'pgadmin.browser', 'pgadmin.file_manager',
-    'pgadmin.file_utility', 'pgadmin.browser.node',
+    'pgadmin.backform', 'pgadmin.backgrid', 'pgadmin.browser',
+    'pgadmin.browser.node',
     'pgadmin.alertifyjs', 'pgadmin.settings', 'pgadmin.preferences', 'pgadmin.sqlfoldcode',
   ],
   // Checks whether JS module is npm module or not
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index 438f6ded4..9a2add644 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -212,6 +212,7 @@ module.exports = {
       'pgadmin.tools.erd': path.join(__dirname, './pgadmin/tools/erd/static/js'),
       'pgadmin.tools.psql': path.join(__dirname, './pgadmin/tools/psql/static/js'),
       'pgadmin.tools.sqleditor': path.join(__dirname, './pgadmin/tools/sqleditor/static/js'),
+      'pgadmin.tools.file_manager': path.join(__dirname, './pgadmin/misc/file_manager/static/js'),
       'pgadmin.authenticate.kerberos': path.join(__dirname, './pgadmin/authenticate/static/js/kerberos'),
       'bundled_codemirror': path.join(__dirname, './pgadmin/static/bundle/codemirror'),
       'tools': path.join(__dirname, './pgadmin/tools/'),
